#ifndef __console_h
#define __console_h

extern void (*my_puts)(const char *s);
extern void (*my_putstring)(const char *s);
extern void (*my_putchar)(char c);

struct console_data_s
{
	unsigned char *framebuffer;
	int xres, yres, stride;
	
	unsigned char *font;
	
	int cursor_x, cursor_y;
	int foreground, background;
	
	int border_left, border_right, border_top, border_bottom;
	
	int scrolled_lines;
};

unsigned long write4(unsigned long val);
void puts(const char *s);
void putstring(const char *s);
void putchar(char c);
void toHex(char *x, unsigned long val, int len);
int printf( const char *fmt, ...);
int set_color(int background, int foreground);

void console_init(void *framebuffer, int xres, int yres, int stride);
void console_puts(struct console_data_s *con, const char *string);
void console_putc(struct console_data_s *con, char c);

#endif
